1. 程式人生 > 其它 >【洛谷P2137】Gty的妹子樹

【洛谷P2137】Gty的妹子樹

題目

題目連結:https://www.luogu.com.cn/problem/P2137
維護一棵初始有 \(n\) 個節點的有根樹(根節點為 \(1\)),樹上節點編號為 \(1 \sim n\),每個點有一個權值 \(w_i\)
支援以下操作:

  • 0 u x 詢問以 \(u\) 為根的子樹中,嚴格大於 \(x\) 的值的個數。
  • 1 u x\(u\) 節點的權值改成 \(x\)
  • 2 u x 新增一個編號為“當前樹中節點數+1”的節點,其父節點為 \(u\),其權值為 \(x\)

本題強制線上。
所有輸入的 \(u,x\) 都需要異或 \(\text{last}\) 才是真正的輸入。
其中 \(\text{last}\)

為上一次詢問的答案,定義初始 \(\text{last} = 0\)

思路

加點強制線上?考慮定期重構。
用一個數據結構維護上一次重構後樹的貢獻,然後再暴力求重構後到現在的修改的貢獻。
求重構的樹的貢獻也就是一棵確定的樹,詢問一個節點子樹內權值嚴格大於 \(k\) 的節點的數量。建一棵以 dfs 序為歷史版本的主席樹即可。因為這道題比較卡常所以需要離散化一下。
對於重構後的操作,因為有加點,並不好通過 dfs 序確定兩點是否為祖孫關係,所以採用倍增。
對於修改權值的操作,如果修改的點是詢問的點的孫子,那就用新權值更新答案;對於加點操作,如果加入的點是詢問的點的孫子,那麼再計算加入的點的貢獻即可。注意一個點被修改多次的情況。我直接從後往前列舉操作,如果這個點是第一次修改才修改。
設每 \(B\)

次操作暴力重構一次,時間複雜度為 \(O(nB\log n+\frac{Qn}{B}\log n)\)。取 \(B=\sqrt{Q}\) 時複雜度為 \(O(Q\sqrt{Q}\log n)\)。建議調調參。

程式碼

#include <bits/stdc++.h>
using namespace std;

const int N=60010,LG=15,Lim=400;
int n,m,m1,Q,tot,cnt,last,a[N],b[N],head[N],id[N],rk[N],siz[N],rt[N],vis[N],dep[N],f[N][LG+1];

struct edge
{
	int next,to;
}e[N*2];

struct node
{
	int opt,x,y;
}c[N];

void add(int from,int to)
{
	e[++tot]=(edge){head[from],to};
	head[from]=tot;
}

void dfs1(int x,int fa)
{
	f[x][0]=fa; dep[x]=dep[fa]+1;
	for (int i=1;i<=LG;i++)
		f[x][i]=f[f[x][i-1]][i-1];
	for (int i=head[x];~i;i=e[i].next)
	{
		int v=e[i].to;
		if (v!=fa) dfs1(v,x);
	}
}

void dfs2(int x,int fa)
{
	id[x]=++cnt; rk[cnt]=x; siz[x]=1;
	for (int i=head[x];~i;i=e[i].next)
	{
		int v=e[i].to;
		if (v!=fa) dfs2(v,x),siz[x]+=siz[v];
	}
}

struct SegTree
{
	int tot,lc[N*LG*4],rc[N*LG*4],cnt[N*LG*4];
	
	int update(int now,int l,int r,int k)
	{
		int x=++tot;
		lc[x]=lc[now]; rc[x]=rc[now]; cnt[x]=cnt[now]+1;
		if (l==r) return x;
		int mid=(l+r)>>1;
		if (k<=mid) lc[x]=update(lc[now],l,mid,k);
			else rc[x]=update(rc[now],mid+1,r,k);
		return x;
	}
	
	int query(int nowl,int nowr,int l,int r,int ql,int qr)
	{
		if (ql<=l && qr>=r) return cnt[nowr]-cnt[nowl];
		int mid=(l+r)>>1,res=0;
		if (ql<=mid) res+=query(lc[nowl],lc[nowr],l,mid,ql,qr);
		if (qr>mid) res+=query(rc[nowl],rc[nowr],mid+1,r,ql,qr);
		return res;
	}
}seg;

void rebuild(int l,int r)
{
	for (int i=1;i<=seg.tot;i++)
		seg.lc[i]=seg.rc[i]=seg.cnt[i]=0;
	seg.tot=cnt=0; dfs2(1,0);
	for (int i=l;i<=r;i++)
		if (c[i].opt==1) a[c[i].x]=c[i].y;
	for (int i=1;i<=m;i++) b[i]=a[i];
	sort(b+1,b+1+m);
	m1=unique(b+1,b+1+m)-b-1;
	for (int i=1;i<=m;i++)
	{
		int val=lower_bound(b+1,b+1+m1,a[rk[i]])-b;
		rt[i]=seg.update(rt[i-1],1,m1,val);
	}
}

bool check(int x,int y)
{
	for (int i=LG;i>=0;i--)
		if (dep[f[x][i]]>=dep[y]) x=f[x][i];
	return x==y;
}

int main()
{
	memset(head,-1,sizeof(head));
	scanf("%d",&n); m=n;
	for (int i=1,x,y;i<n;i++)
	{
		scanf("%d%d",&x,&y);
		add(x,y); add(y,x);
	}
	dfs1(1,0);
	for (int i=1;i<=n;i++)
		scanf("%d",&a[i]);
	rebuild(1,0);
	scanf("%d",&Q);
	for (int i=1,j=0,x,y;i<=Q;i++)
	{
		scanf("%d%d%d",&c[i].opt,&x,&y);
		c[i].x=x=x^last; c[i].y=y=y^last;
		if (c[i].opt==0)
		{
			y++;
			int z=lower_bound(b+1,b+1+m1,y)-b;
			if (id[x]) last=seg.query(rt[id[x]-1],rt[id[x]+siz[x]-1],1,m1,z,m1);
				else last=0;
			for (int k=i;k>j;k--)
				if (c[k].opt==2 && a[c[k].x]>=y && check(c[k].x,x)) last++;
			for (int k=i;k>j;k--)
				if (c[k].opt==1 && vis[c[k].x]<i)
				{
					vis[c[k].x]=i;
					if (check(c[k].x,x))
					{
						if (a[c[k].x]>=y) last--;
						if (c[k].y>=y) last++;
					}
				}
			cout<<last<<"\n";
		}
		if (c[i].opt==2)
		{
			a[++m]=c[i].y; add(c[i].x,m);
			f[m][0]=c[i].x; dep[m]=dep[c[i].x]+1;
			for (int i=1;i<=LG;i++)
				f[m][i]=f[f[m][i-1]][i-1];
			c[i].x=m;
		}
		if (i%Lim==0) rebuild(j+1,i),j=i;
	}
	return 0;
}